// Keygen for IceZmodem 1.10 - akacastor 2024-01-22

#include <stdio.h>
#include <string.h>


/*
- pick build key (5 bytes expanded to 15)

- username ^= build key

1 4 2 0 3   then 5,6,7....

take byte from username, and for each nibble pick the index value from     char check_key[17] = "7L8N9HBPDAKECMGI";
*/
int main(int argc, char**argv)
{
    char init_key[5] = "ABCDE";
    char build_key[0xF];
    char username[20] = "NoBoDy!";
    char serialkey[60] = {0};
    char check_key[16] = "7L8N9HBPDAKECMGI";
    int i;
    int username_len;
    int max_serialkey_len = 59;


    printf("IceZmodem 1.10 keygen by akacastor - 2023-01-21\n\n");

    if( argc > 1 )
    {
        strncpy( username, argv[1], sizeof(username) );
        username[sizeof(username)-1] = '\0';
    }

    printf( "Username: '%s'\n", username );

    for( i=0; i<5; i++ )
        build_key[i] = init_key[i] + 0x78;

    for( i=0; i<5; i++ )
        build_key[5+i] = build_key[i] + 0x32;

    for( i=0; i<5; i++ )
        build_key[0xA+i] = build_key[i] + 0x14;

    username_len = strlen(username);
    for(i=0; i<username_len; i++)
        username[i] ^= build_key[i%0xF];

    serialkey[3*2] = check_key[(username[0]>>4)&0x0F];
    serialkey[(3*2)+1] = check_key[(username[0]&0x0F)];        
    serialkey[0*2] = check_key[(username[1]>>4)&0x0F];
    serialkey[(0*2)+1] = check_key[(username[1]&0x0F)];        
    serialkey[2*2] = check_key[(username[2]>>4)&0x0F];
    serialkey[(2*2)+1] = check_key[(username[2]&0x0F)];        
    serialkey[4*2] = check_key[(username[3]>>4)&0x0F];
    serialkey[(4*2)+1] = check_key[(username[3]&0x0F)];        
    serialkey[1*2] = check_key[(username[4]>>4)&0x0F];
    serialkey[(1*2)+1] = check_key[(username[4]&0x0F)];        

    for(i=5; i<username_len && i < (max_serialkey_len/2); i++)
    {
        serialkey[i*2] = check_key[(username[i]>>4)&0x0F];
        serialkey[(i*2)+1] = check_key[(username[i]&0x0F)];
    }

    printf( "Reg key: " );
    for(i=0; i<username_len && i<(max_serialkey_len/2); i++ )
    {
        if( i == 1 )
            printf("%c",init_key[0]);
        if( i == 2 )
            printf("%c",init_key[1]);
        if( i == 3 )
            printf("%c",init_key[2]);
        if( i == 4 )
            printf("%c",init_key[3]);
        if( i == 5 )
            printf("%c",init_key[4]);
        printf("%c%c",serialkey[i*2],serialkey[(i*2)+1]);
    }
    printf("\n");

    return 0;
}
